/*
 * JBoss, Home of Professional Open Source.
 * See the COPYRIGHT.txt file distributed with this work for information
 * regarding copyright ownership.  Some portions may be licensed
 * to Red Hat, Inc. under one or more contributor license agreements.
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
 * 02110-1301 USA.
 * Modified by
 * @author  Data Virtuality GmbH
 * @date    $Date$
 *  
 */

package org.teiid.dqp.internal.datamgr;

import org.junit.jupiter.api.Test;
import org.teiid.language.ScalarSubquery;
import org.teiid.language.Select;
import org.teiid.query.sql.lang.Query;
import org.teiid.query.sql.symbol.Expression;
import static org.junit.jupiter.api.Assertions.*;

/**
 */
public class TestScalarSubqueryImpl {

    public static org.teiid.query.sql.symbol.ScalarSubquery helpExample() {
        Query query = TestQueryImpl.helpExample(true);
        org.teiid.query.sql.symbol.ScalarSubquery ss = new org.teiid.query.sql.symbol.ScalarSubquery(query);
        ss.setType(((Expression)query.getProjectedSymbols().get(0)).getType());
        return ss;
    }
    
    public static ScalarSubquery example() throws Exception {
        return (ScalarSubquery)TstLanguageBridgeFactory.factory.translate(helpExample());
    }

    @Test
    public void testGetQuery() throws Exception {
        assertNotNull(example().getSubquery());    }

    @Test
    public void testGetType() throws Exception {
        Select query = TstLanguageBridgeFactory.factory.translate(TestQueryImpl.helpExample(true));
        Class<?> firstSymbolType = query.getDerivedColumns().get(0).getExpression().getType();
        assertEquals(firstSymbolType, example().getType(), "Got incorrect type"); //$NON-NLS-1$
    }
    
}
